#ifndef COMMON_H
#define COMMON_H

/* Exported macros -----------------------------------------------------------*/
			

/* Exported types ------------------------------------------------------------*/
#include "stdbool.h"
#include "wit_config.h"
#include "update_config.h"

typedef struct
{
	unsigned short 	usYear;
	unsigned char	ucMonth;
	unsigned char 	ucDay;
	unsigned char 	ucHour;
	unsigned char 	ucMinute;
	unsigned char	ucSecond;
} Calendar;

/* Exported functions --------------------------------------------------------*/

void 			Delay_us(double dTime_us);
void 			Delay_ms(double dTime_ms);
void 			Delay_s(double dTime_s);
void 			Split(char *pcSplitedData[], unsigned char ucSplitedArraySize, char *pcSource, char *pcSymbol);
void 			CutString(char *pcDestination, unsigned long ulDestinationSize, char *pcSource, char *pcStart, char *pcEnd);
unsigned long	TimeToTimeStamp(Calendar *pxCalendar);
void			TimeStampToTime(unsigned long ulTimeStamp, Calendar *pxCalendar);
unsigned char 	ByteToBCD(unsigned char ucByte);
unsigned char 	BCDToByte(unsigned char ucBCD);
bool			GetFlagStatus(unsigned long *pulFlag, unsigned char ucBitPosition);
void			SetFlagStatus(unsigned long *pulFlag, unsigned char ucBitPosition, bool bStatus);
char *			memstr(void *pvSrc, char *pcStr, unsigned long ulLength);
bool 			Replace(char *pcOrigin, char *pcSearch, char *pcReplace, char *pcDest, unsigned long ulMaxLength);
double 			Round(double dValue, unsigned char ucPrecision);
#endif

