#include "if_ble_config.h"
#include "flash.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include <string.h>
#include "esp_log.h"
#include "if_apkg_code.h"
#include "wit.h"

extern bool g_bIsLowPower;

#define  DEALY_TIME          (3 / portTICK_PERIOD_MS)

Sensor_Config g_xSensorConfig[WIT_SENSOR_GROUP_MAX_NUM * WIT_SENSOR_MAX_CONNECT_NUM];

static bool if_clear_flag_config(unsigned int index);
static bool if_config_operation(unsigned int index, unsigned char point, bool bCheck);
static bool if_set_speed_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_bearing_config(unsigned short usExtendBearing, char cBearingFlag, unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_gear_config(unsigned short usExtendGear, char cGearFlag, unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_fan_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_belt_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_screw_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_shaft_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_female_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_male_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_sample_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);
static bool if_set_vibration_threshold_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck);

void if_sensor_config_init(void)
{
    // ESP_LOGD("sconfig","%d",sizeof(g_xSensorConfig));
    // for(int i= 0 ; i < WIT_SENSOR_GROUP_MAX_NUM * WIT_SENSOR_MAX_CONNECT_NUM ; i++ ) {
    //     g_xSensorConfig[i].usSamplingCount = SENSOR_WAVE_MAX_SIZE;
    //     g_xSensorConfig[i].usAutoModeSamplingPeriod = 10;
    //     g_xSensorConfig[i].sXOffset = 0;
    //     g_xSensorConfig[i].sYOffset = 0;
    //     g_xSensorConfig[i].sZOffset = 0;
    //     g_xSensorConfig[i].bSetSpeed = false;
    //     memset(&g_xSensorConfig[i].xBearing, 0, SENSOR_BEARING_LOGITIC_MAX_SIZE * sizeof(Bearing));
    //     memset(&g_xSensorConfig[i].xGear, 0, SENSOR_GEAR_LOGITIC_MAX_SIZE * sizeof(Gear));
    //     g_xSensorConfig[i].bAutoDeleteGravity = true;
    //     g_xSensorConfig[i].ulFrequencyRange = 5;
    //     g_xSensorConfig[i].eMode = Mode_Auto;
    //     g_xSensorConfig[i].bCalculateFeature = true;
    //     g_xSensorConfig[i].usActiveThreshold = 80;
    //     g_xSensorConfig[i].usActiveRatio = 30;
    //     memset((unsigned char *)&g_xSensorConfig[i].xBaseExtendConfig, 0, sizeof(Base_ExtendConfig));
    //     memset((unsigned char *)&g_xSensorConfig[i].xGearExtendConfig, 0, SENSOR_GEAR_LOGITIC_MAX_SIZE * sizeof(Gear_ExtendConfig));
    //     g_xSensorConfig[i].xBaseExtendConfig.usHPFCutOffFreq = 4000;
    //     g_xSensorConfig[i].xBaseExtendConfig.usPeakVueHPFCutOffFreq = 500; 
    //     g_xSensorConfig[i].xBaseExtendConfig.usPeakVueMaxFreq = 1000;
    //     g_xSensorConfig[i].xBaseExtendConfig.usButterworthN = 4;
    //     for (int j = 0; j < SENSOR_BEARING_MAX_COUNT; j++)
    //     {
    //         g_xSensorConfig[i].xBearingExtendConfig[j].usAlias = j + 1;
    //     }

    //     for (int j = 0; j < SENSOR_GEAR_MAX_COUNT; j++)
    //     {
    //         g_xSensorConfig[i].xGearExtendConfig[j].usAlias = j + 1;
    //     }
    //     memset(&g_xSensorConfig[i].xFan, 0, sizeof(g_xSensorConfig[i].xFan));
    //     memset(&g_xSensorConfig[i].xBelt, 0, sizeof(g_xSensorConfig[i].xBelt));

    // // 这里合并了掉xFan和 Enable FanAlias 
    //     g_xSensorConfig[i].bFanEnable = false;
    //     g_xSensorConfig[i].bBeltEnable = false;
    //     g_xSensorConfig[i].usFanAlias = 1;
    //     g_xSensorConfig[i].usBeltAlias = 1;
    //     memset(&g_xSensorConfig[i].xScrew, 0, sizeof(g_xSensorConfig[i].xScrew));
    //     g_xSensorConfig[i].bScrewEnable = false;
    //     g_xSensorConfig[i].usScrewAlias = 1;
    //     memset(&g_xSensorConfig[i].xShaft, 0, sizeof(g_xSensorConfig[i].xShaft));
    //     g_xSensorConfig[i].bShaftEnable = false;
    //     g_xSensorConfig[i].usShaftAlias = 1;
    //     memset(&g_xSensorConfig[i].xFemaleScrew, 0, sizeof(g_xSensorConfig[i].xFemaleScrew));
    //     g_xSensorConfig[i].bFemaleScrewEnable = false;
    //     g_xSensorConfig[i].usFemaleScrewAlias = 1;
    //     memset(&g_xSensorConfig[i].xMaleScrew, 0, sizeof(g_xSensorConfig[i].xMaleScrew));
    //     g_xSensorConfig[i].bMaleScrewEnable = false;
    //     g_xSensorConfig[i].usMaleScrewAlias = 1;
    //     g_xSensorConfig[i].odr = 0;
    //     g_xSensorConfig[i].usSamplingCount = 8192; //8192;
    //     g_xSensorConfig[i].amlVibTh = 10000;
    //     g_xSensorConfig[i].amlVibInterval = 5 * 60;
    //     g_xSensorConfig[i].amlVibKeepCnt = 10;
    //     g_xSensorConfig[i].highTempProtect = 1;
    //     g_xSensorConfig[i].bSleeveEnable = false;
    //     g_xSensorConfig[i].usSleeveAlias = 1;
    //     g_xSensorConfig[i].xPwrFreq.fPassFrequency = 50.0f;

    //     g_xSensorConfig[i].ulSpeed = 1500;


    // }             
    if_falsh_read_config();
}

bool if_sensor_config(unsigned int index, unsigned char point, unsigned long *ulConfigEnable)
{
    bool bStatus = true;
    if(*ulConfigEnable == 1 && ulConfigEnable != NULL) {
        if(if_config_operation(index, point, false) == true)
            *ulConfigEnable = 0;  
        else
            bStatus = false; 
    }
    return bStatus;
}

Sensor_Config *getSensorConfig(unsigned char index)
{
    return &g_xSensorConfig[index];
} 

void if_falsh_write_config(void)
{
   write_flash(E_SEN_CONFIG, g_xSensorConfig, sizeof(g_xSensorConfig));
}

void if_falsh_read_config(void)
{
    read_flash(E_SEN_CONFIG, g_xSensorConfig, sizeof(g_xSensorConfig));
}

static bool if_config_operation(unsigned int index, unsigned char point, bool bCheck)
{ 
    bool           bStatus = true;
    Sensor_Config  *pxSenConfig = NULL;
    unsigned char  ucRepeat;
    
    pxSenConfig = getSensorConfig(point); 
    if_clear_flag_config(index);
    // 转速设置
    if(pxSenConfig->bSetSpeed == 1)
    {
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_speed_config(index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config","speed config fail");
        }
    }
    // 轴承配置
    if(pxSenConfig->xBaseExtendConfig.usBearingExtendFlag != 0 || pxSenConfig->bBearingEnabled[0] == true || pxSenConfig->bBearingEnabled[1] == true)
    {
        unsigned char cBearing = 0;
        for(int z = 0; z < SENSOR_BEARING_MAX_COUNT; z++ )
        {
           if(pxSenConfig->bBearingEnabled[z]) 
            cBearing |=  1 << z;
        }
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_bearing_config(pxSenConfig->xBaseExtendConfig.usBearingExtendFlag, cBearing, index, pxSenConfig, bCheck) == true)
                break;
            else
            ESP_LOGD("config","bearing config fail"); 
        }
    }
    
    // 齿轮配置
    if(pxSenConfig->xBaseExtendConfig.usGearExtendFlag != 0|| pxSenConfig->bGearEnabled[0] == true || pxSenConfig->bGearEnabled[1] == true || pxSenConfig->bGearEnabled[2] == true)
    {
        unsigned char cGear = 0;
        for(int z = 0; z < SENSOR_GEAR_MAX_COUNT; z++ )
        {
           if(pxSenConfig->bGearEnabled[z]) 
            cGear |=  1 << z;
        }
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_gear_config(pxSenConfig->xBaseExtendConfig.usGearExtendFlag, cGear, index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config","gear config fail");   
        }
    }
    // 风机配置
    if(pxSenConfig->bFanEnable == 1)
    {
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_fan_config(index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config","fan config fail");    
        }
    }
    
    // 皮带配置
    if(pxSenConfig->bBeltEnable == 1)
    {
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_belt_config(index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config","belt config fail");    
        }
    }
    // 螺杆配置
    if(pxSenConfig->bScrewEnable == 1)
    {
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_screw_config(index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config","screw config fail");    
        }
    }
    // 传动轴配置
    if(pxSenConfig->bShaftEnable == 1)
    {
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_shaft_config(index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config","shaft config fail");    
        }
    }
    
    // 阴螺杆配置
    if(pxSenConfig->bFemaleScrewEnable == 1)
    {
        ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_female_config(index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config","female config fail");    
        }
    }

    if(pxSenConfig->bMaleScrewEnable == 1)
    {
         ucRepeat = RETARY_CNT;
        while(ucRepeat--)
        {
            if(if_set_male_config(index, pxSenConfig, bCheck) == true)
                break;
            else
                ESP_LOGD("config"," male config fail");    
        }
    }
    ucRepeat = RETARY_CNT;
    while(ucRepeat--)
    {
        if(if_set_vibration_threshold_config(index, pxSenConfig, bCheck) == true)
            break;
        else
            ESP_LOGD("config","sample config fail");    
    }
    return bStatus;

    ucRepeat = RETARY_CNT;
    while(ucRepeat--)
    {
        if(if_set_sample_config(index, pxSenConfig, bCheck) == true)
            break;
        else
            ESP_LOGD("config","sample config fail");    
    }
    if(g_bIsLowPower)
    {
        // ucRepeat = RETARY_CNT;
        // while(ucRepeat--)
        // {
        //     if(eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_BEARING_APKG_CONFIG_FLAG_ADDR , SENSOR_PARTS_MAX_NUM, flag) == WCP_OK)
        //         break;
        //     else
        //         ESP_LOGD("config","sample config fail");    
        // }
    }
    return bStatus;
}

static bool if_clear_flag_config(unsigned int index)
{
    bool           bIsCorrect        = true;
    unsigned char flag[SENSOR_PARTS_MAX_NUM] = {0};
    eWCPinfo       ei;

    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_BEARING_APKG_CONFIG_FLAG_ADDR , SENSOR_PARTS_MAX_NUM, flag);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_EXTEND_INPUTSPEED_FLAG_APKG_ADDR , 8, flag);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    return  bIsCorrect;
}

static bool if_set_speed_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    unsigned short usReadSpeed       = 0;
    unsigned short usWriteSpeed      = 1500;
    bool           bIsCorrect        = true;
    eWCPinfo       ei;
    usWriteSpeed = (unsigned short)pxSenConfig->ulSpeed;
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_INPUTSPEED_APKG_ADDR, 2, (unsigned char *)&usWriteSpeed);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);

    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_INPUTSPEED_APKG_ADDR , 2, (unsigned char *)&usReadSpeed);
        if(usReadSpeed != usWriteSpeed && ei != WCP_OK)
            bIsCorrect = false;       
    }
    return bIsCorrect;
}

static bool if_set_bearing_config(unsigned short usExtendBearing, char cBearingFlag, unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    char           cBearing[32] = {0};
    unsigned short usCnt = 0;
    unsigned short usData = 0;
    unsigned char  ucNum = 0;
    bool           bIsCorrect = true;
    eWCPinfo       ei; 
    unsigned long address = 0;
    for(int i = 0 ; i < SENSOR_BEARING_MAX_COUNT ; i++ ) 
    {
        usCnt = 0;
        usData = 0;
        ucNum = 0;
        if(((usExtendBearing >> i) && 0x01) == 0x01 || ((cBearingFlag >> i) && 0x01) == 0x01)
        {
            if(i == 0)
            {   
                if((cBearingFlag >> i) && 0x01 == 0x01)
                    address = SENSOR_BEARING_APKG_CONFIG_ADDR;
                else
                    address = 0x00000164;
            }
            else
            {
                if((cBearingFlag >> i) && 0x01 == 0x01)
                    address = 0x00000169;
                else
                    address = 0x00000173;
            }
            if((cBearingFlag >> i && 0x01) == 0x01)
            {
                usData = (unsigned short)(pxSenConfig->xBearing[i].fRotateSpeed * 100);
                memcpy(cBearing+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);
                usData = (unsigned short)(pxSenConfig->xBearing[i].fBPFO * 100);
                memcpy(cBearing+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);  
                usData = (unsigned short)(pxSenConfig->xBearing[i].fBPFI * 100);
                memcpy(cBearing+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);
                usData = (unsigned short)(pxSenConfig->xBearing[i].fBSF * 100);
                memcpy(cBearing+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);
                usData = (unsigned short)(pxSenConfig->xBearing[i].fFTF * 100);
                memcpy(cBearing+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);
            }
            if((usExtendBearing >> i && 0x01) == 0x01)
            {
                usData = (unsigned short)pxSenConfig->xBearingExtendConfig[i].usStartFreq;
                ESP_LOGD("bearing","start freq :%d",pxSenConfig->xBearingExtendConfig[i].usStartFreq);
                memcpy(cBearing+usCnt, &usData , sizeof(usData));
                usCnt += sizeof(usData);
                usData = (unsigned short)pxSenConfig->xBearingExtendConfig[i].usStopFreq;
                ESP_LOGD("bearing","stop freq :%d",pxSenConfig->xBearingExtendConfig[i].usStopFreq);
                memcpy(cBearing+usCnt, &usData , sizeof(usData));
                usCnt += sizeof(usData);
            }
            ucNum = (unsigned char)(pxSenConfig->xBearingExtendConfig[i].usAlias);
            memcpy(cBearing+usCnt, &ucNum, sizeof(ucNum));
            usCnt += sizeof(ucNum);
            ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, address, usCnt, cBearing);
            if(ei != WCP_OK)
                bIsCorrect = false;
            vTaskDelay(DEALY_TIME);
            if(bCheck == true && bIsCorrect == true)
            {
                
            }
        }
    }

    return  bIsCorrect;
}

static bool if_set_gear_config(unsigned short usExtendGear, char cGearFlag, unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    char           cGear[32] = {0};
    unsigned short usCnt = 0;
    unsigned short usData = 0;
    unsigned char  ucNum = 0;
    bool           bIsCorrect = true;
    unsigned long  address = 0;
    eWCPinfo       ei; 

    for(int i = 0 ; i < SENSOR_GEAR_MAX_COUNT ; i++ ) 
    {
        usCnt = 0;
        usData = 0;
        ucNum = 0;
        if(i == 0)
        {   
            if((cGearFlag >> i) && 0x01 == 0x01)
                address = SENSOR_GEAR_APKG_CONFIG_ADDR;
            else
                address = 0x0000018E;
        }
        else if(i == 1)
        {
            if((cGearFlag >> i) && 0x01 == 0x01)
                address = 0x00000195;
            else
                address = 0x0000019B;
        }
        else
        {
           if((cGearFlag >> i) && 0x01 == 0x01)
                address = 0x000001A2;
            else
                address = 0x000001A8; 
        }
        if((cGearFlag >> i && 0x01) == 0x01)
        {
                usData = (unsigned short)(pxSenConfig->xGear[i].fTeethCount * 100);
                memcpy(cGear+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);
                usData = (unsigned short)(pxSenConfig->xGear[i].fRotateSpeed * 100);
                memcpy(cGear+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);  
                usData = (unsigned short)(pxSenConfig->xGear[i].f1xGMF * 100);
                memcpy(cGear+usCnt, &usData, sizeof(usData));
                usCnt += sizeof(usData);
        }
        if((usExtendGear >> i && 0x01) == 0x01)
        {
            usData = (unsigned short)pxSenConfig->xGearExtendConfig[i].usStartFreq;
            memcpy(cGear+usCnt, &usData , sizeof(usData));
            usCnt += sizeof(usData);
            usData = (unsigned short)pxSenConfig->xGearExtendConfig[i].usStopFreq;
            memcpy(cGear+usCnt, &usData , sizeof(usData));
            usCnt += sizeof(usData);
            usData = (unsigned short)pxSenConfig->xGearExtendConfig[i].usSideRange;
            memcpy(cGear+usCnt, &usData , sizeof(usData));
            usCnt += sizeof(usData);
        }   
        ucNum = (unsigned char)(pxSenConfig->xGearExtendConfig[i].usAlias);
        memcpy(cGear+usCnt, &ucNum, sizeof(ucNum));
        usCnt += sizeof(ucNum);
        ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, address, usCnt, cGear);
        if(ei != WCP_OK)
            bIsCorrect = false;
        vTaskDelay(DEALY_TIME);
        if(bCheck == true && bIsCorrect == true)
        {
            
        }
    }
    return  bIsCorrect;
}

static bool if_set_fan_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    unsigned char  cWriteFan[8] = {0};
    unsigned char  cReadFan[8]  = {0};
    unsigned short usCnt        = 0;
    unsigned char  ucFanNum     = 0;
    unsigned int   usData       = 0;
    bool           bIsCorrect    = true;
    eWCPinfo       ei; 
    
    usData = (unsigned int)(pxSenConfig->xFan.fPassFrequency * 100);
    memcpy(cWriteFan, &usData, sizeof(usData));
    usCnt += sizeof(usData);
    ucFanNum = (unsigned char)(pxSenConfig->usFanAlias);
    memcpy(cWriteFan+usCnt, &ucFanNum, sizeof(ucFanNum));
    usCnt += sizeof(ucFanNum);
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_FAN_APKG_CONFIG_ADDR, usCnt, cWriteFan);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_INPUTSPEED_APKG_ADDR , usCnt, cReadFan);
        if(ei == WCP_OK)
        {   
            if(strstr((char *)cReadFan,  (char *)cWriteFan) == NULL)
                bIsCorrect = false;   
        }
        else
        {
            bIsCorrect = false;   
        }    
    }
    return bIsCorrect;
}

static bool if_set_belt_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    unsigned char cWriteBelt[12] = {0};
    unsigned char cReadBelt[12]  = {0}; 
    unsigned int   uiData = 0;
    unsigned short usCnt        = 0;
    unsigned char  ucWritecBelt = 0;
    bool           bIsCorrect   = true;
    eWCPinfo       ei; 

    uiData = (unsigned int)(pxSenConfig->xBelt.fPassFrequency * 100);
    memcpy(cWriteBelt, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    uiData = (unsigned int)(pxSenConfig->xBelt.fSelfVirbFreq * 100);
    memcpy(cWriteBelt+usCnt, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    ucWritecBelt = (unsigned char)(pxSenConfig->usBeltAlias);
    memcpy(cWriteBelt+usCnt, &ucWritecBelt, sizeof(ucWritecBelt));
    usCnt += sizeof(ucWritecBelt); 
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_BELT_APKG_CONFIG_ADDR, usCnt, cWriteBelt);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_BELT_APKG_CONFIG_ADDR , usCnt, cReadBelt);
        if(ei == WCP_OK)
        {   
            if(strstr((char *)cReadBelt,  (char *)cWriteBelt) == NULL)
                bIsCorrect = false;   
        }
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;
}

static bool if_set_screw_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    char          cWriteScrew[6] = {0};
    char          cReadScrew[6]  = {0}; 
    unsigned short usCnt         = 0;
    unsigned int  uiData         = 0;
    unsigned char ucDataNum      = 0;
    bool          bIsCorrect     = true;
    eWCPinfo      ei;   

    uiData = (unsigned int)(pxSenConfig->xScrew.fPassFrequency * 100);
    memcpy(cWriteScrew, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    ucDataNum = (unsigned char)pxSenConfig->usScrewAlias;
    memcpy(cWriteScrew+usCnt, &ucDataNum, sizeof(ucDataNum));
    usCnt += sizeof(ucDataNum); 
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SCREW_APKG_CONFIG_ADDR, usCnt, cWriteScrew);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SCREW_APKG_CONFIG_ADDR , usCnt, (unsigned char *)cReadScrew);
        if(ei == WCP_OK)
        {   
            if(strstr(cReadScrew,  cWriteScrew) == NULL)
                bIsCorrect = false;   
        } 
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;
}

static bool if_set_shaft_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    char          cWriteShaft[6] = {0};
    char          cReadShaft[6]  = {0}; 
    unsigned short usCnt         = 0;
    unsigned int  uiData         = 0;
    unsigned char ucDataNum      = 0;
    bool          bIsCorrect     = true;
    eWCPinfo      ei;   

    uiData = (unsigned int)(pxSenConfig->xShaft.fPassFrequency * 100);
    memcpy(cWriteShaft, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    ucDataNum = (unsigned char)pxSenConfig->usShaftAlias;
    memcpy(cWriteShaft+usCnt, &ucDataNum, sizeof(ucDataNum));
    usCnt += sizeof(ucDataNum); 
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SHAFT_APKG_CONFIG_ADDR, usCnt, cWriteShaft);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SHAFT_APKG_CONFIG_ADDR , usCnt, (unsigned char *)cReadShaft);
        if(ei == WCP_OK)
        {   
            if(strstr(cReadShaft,  cWriteShaft) == NULL)
                bIsCorrect = false;   
        } 
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;
}

static bool if_set_female_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    unsigned char cWriteFeMale[12] = {0};
    unsigned char cReadFeMale[12]  = {0}; 
    unsigned int   uiData = 0;
    unsigned short usCnt        = 0;
    unsigned char  ucWriteFeMale = 0;
    bool           bIsCorrect   = true;
    eWCPinfo       ei; 

    uiData = (unsigned int)(pxSenConfig->xFemaleScrew.fPassFrequency * 100);
    memcpy(cWriteFeMale, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    uiData = (unsigned int)(pxSenConfig->xFemaleScrew.fSpeed * 100);
    memcpy(cWriteFeMale + usCnt, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    ucWriteFeMale = (unsigned char)(pxSenConfig->usFemaleScrewAlias);
    memcpy(cWriteFeMale + usCnt, &ucWriteFeMale, sizeof(ucWriteFeMale));
    usCnt += sizeof(ucWriteFeMale); 
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_FEMALESCREW_APKG_CONFIG_ADDR, usCnt, cWriteFeMale);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_FEMALESCREW_APKG_CONFIG_ADDR , usCnt, cReadFeMale);
        if(ei == WCP_OK)
        {   
            if(strstr((char *)cReadFeMale,  (char *)cWriteFeMale) == NULL)
                bIsCorrect = false;   
        }
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;  
}

static bool if_set_male_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
        unsigned char cWriteMale[12] = {0};
    unsigned char cReadMale[12]  = {0}; 
    unsigned int   uiData = 0;
    unsigned short usCnt        = 0;
    unsigned char  ucWriteMale = 0;
    bool           bIsCorrect   = true;
    eWCPinfo       ei; 

    uiData = (unsigned int)(pxSenConfig->xMaleScrew.fPassFrequency * 100);
    memcpy(cWriteMale + usCnt, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    uiData = (unsigned int)(pxSenConfig->xMaleScrew.fSpeed * 100);
    memcpy(cWriteMale + usCnt, &uiData, sizeof(uiData));
    usCnt += sizeof(uiData); 
    ucWriteMale = (unsigned char)(pxSenConfig->usMaleScrewAlias);
    memcpy(cWriteMale + usCnt, &ucWriteMale, sizeof(ucWriteMale));
    usCnt += sizeof(ucWriteMale); 
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_MALESCREW_APKG_CONFIG_ADDR, usCnt, cWriteMale);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME);
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_MALESCREW_APKG_CONFIG_ADDR , usCnt, cReadMale);
        if(ei == WCP_OK)
        {   
            if(strstr((char *)cReadMale,  (char *)cWriteMale) == NULL)
                bIsCorrect = false;   
        }
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect; 
}

static bool if_set_vibration_threshold_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
 
    unsigned short ucxVarWrite = 0;
    unsigned short ucxVarRead = 0;
    bool  bIsCorrect = true;
    eWCPinfo      ei; 

    ucxVarWrite = pxSenConfig->usxVar;
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_XVAR_APKG_ADDR, 2, &ucxVarWrite);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME); 
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_XVAR_APKG_ADDR, 2, (unsigned char *)&ucxVarRead);
        if(ei == WCP_OK)
        {   
            if(ucxVarWrite != ucxVarRead)
                bIsCorrect = false;   
        } 
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;
}

static bool if_set_sample_config(unsigned int index, Sensor_Config  *pxSenConfig, bool bCheck)
{
    unsigned short usSampleNum = 0;
    unsigned short usRSampleNum = 0;
    bool  bIsCorrect = true;
    eWCPinfo      ei; 

    usSampleNum = pxSenConfig->usSamplingCount;
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SAMPLE_APKG_ADDR, 2, &usSampleNum);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME); 
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SAMPLE_APKG_ADDR, 2, (unsigned char *)&usRSampleNum);
        if(ei == WCP_OK)
        {   
            if(usRSampleNum != usSampleNum)
                bIsCorrect = false;   
        } 
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;
}

bool if_synchronize_time(unsigned int index, unsigned long ulSyncTime, bool bCheck)
{
    eWCPinfo     ei; 
    bool         bIsCorrect = true;
    unsigned long ulReadSyncTime = 0;
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SYNC_TIME_APKG_ADDR, 4, &ulSyncTime);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME); 
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_SYNC_TIME_APKG_ADDR, 4, (unsigned char *)&ulReadSyncTime);
        if(ei == WCP_OK)
        {   
            if(ulReadSyncTime != ulSyncTime)
                bIsCorrect = false;   
        } 
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;
}

bool if_set_collect_time(unsigned int index, unsigned long ulConnectTime, bool bCheck)
{
    eWCPinfo     ei; 
    bool         bIsCorrect = true;
    unsigned long ulReadConnectTime = 0;
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_COLLECT_TIME_APKG_ADDR, 4, &ulConnectTime);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME); 
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_COLLECT_TIME_APKG_ADDR, 4, (unsigned char *)&ulReadConnectTime);
        if(ei == WCP_OK)
        {   
            if(ulReadConnectTime != ulConnectTime)
                bIsCorrect = false;   
        } 
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;
}

bool if_set_wakeup_time(unsigned int index, unsigned long ulWakeUpTime, unsigned long ulWakeUpInterval, bool bCheck)
{
    eWCPinfo     ei; 
    char cWriteData[8]  = {0};
    char cReadData[8]   = {0};
    unsigned short usCnt = 0;
    bool           bIsCorrect = true;
   
    memcpy(cWriteData, &ulWakeUpTime, sizeof(ulWakeUpTime));
    usCnt += sizeof(ulWakeUpTime); 
    memcpy(cWriteData + usCnt, &ulWakeUpInterval, sizeof(ulWakeUpInterval));
    usCnt += sizeof(ulWakeUpInterval); 
    ei = eWCPWriteDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_WAKEUP_TIME_APKG_ADDR, usCnt, &cWriteData);
    if(ei != WCP_OK)
        bIsCorrect = false;
    vTaskDelay(DEALY_TIME); 
    if(bCheck == true && bIsCorrect == true)
    {
        ei = eWCPReadDataAddress(index, SENSOR_CHR_WRITE_HANDLER, SENSOR_WAKEUP_TIME_APKG_ADDR, usCnt, (unsigned char *)&cReadData);
        if(ei == WCP_OK)
        {   
            for(int i = 0 ; i < usCnt ; i++)
            {
                if(cWriteData[i] != cReadData[i])
                {
                    bIsCorrect = false; 
                    break; 
                }
            } 
        } 
        else
        {
            bIsCorrect = false;   
        }
    }
    return bIsCorrect;       
}


void if_check_change_config(void)
{
    // 读取备份配置数据

    // 检查配置数据和备份配置数据是否相同，如果相同，配置不下发，如果不同，配置下发   
}

void if_printf(void)
{
    printf(".............");
    printf("0, bear enable %d\r\n", g_xSensorConfig[0].xBaseExtendConfig.usBearingExtendFlag);
    printf("0, bear usStartFreq %d\r\n", g_xSensorConfig[0].xBearingExtendConfig[0].usStartFreq);
    printf("0, bear usStopFreq %d\r\n", g_xSensorConfig[0].xBearingExtendConfig[0].usStopFreq);
    printf("0, bear usStartFreq %d\r\n", g_xSensorConfig[0].xBearingExtendConfig[1].usStartFreq);
    printf("0, bear usStopFreq %d\r\n", g_xSensorConfig[0].xBearingExtendConfig[1].usStopFreq);
    printf("1, bear usStartFreq %d\r\n", g_xSensorConfig[1].xBearingExtendConfig[0].usStartFreq);
    printf("1, bear usStopFreq %d\r\n", g_xSensorConfig[1].xBearingExtendConfig[0].usStopFreq);
    printf("1, bear usStartFreq %d\r\n", g_xSensorConfig[1].xBearingExtendConfig[1].usStartFreq);
    printf("1, bear usStopFreq %d\r\n", g_xSensorConfig[1].xBearingExtendConfig[1].usStopFreq);
    printf("2, bear usStartFreq %d\r\n", g_xSensorConfig[2].xBearingExtendConfig[0].usStartFreq);
    printf("2, bear usStoptFreq %d\r\n", g_xSensorConfig[2].xBearingExtendConfig[0].usStopFreq);
    printf("2, bear usStartFreq %d\r\n", g_xSensorConfig[2].xBearingExtendConfig[1].usStartFreq);
    printf("2, bear usStoptFreq %d\r\n", g_xSensorConfig[2].xBearingExtendConfig[1].usStopFreq);
    // printf("0, config %p\r\n", &g_xSensorConfig[0]);
}