#ifndef SIMCOM_HTTP_H
#define SIMCOM_HTTP_H
/* Includes ------------------------------------------------------------------*/
#include "common.h"
#include "celluar_comm.h"

#if SIMCOM > 0
#if CELLUAR_HTTP_ENABLE > 0
/* Exported types ------------------------------------------------------------*/
typedef enum
{
	GET = 0,
	POST = 1,
	HEAD = 2,
	DELETE = 3
} HTTPMethod;

/* Exported functions --------------------------------------------------------*/
Celluar_ErrorStatus SIMCom_InitializeHTTPService(void);
Celluar_ErrorStatus SIMCom_SetHTTPParametersValue(char *pcParameter, char *pcValue, unsigned long ulValue);
Celluar_ErrorStatus SIMCom_HTTPAction(HTTPMethod eMethod, unsigned long *pulResponseLen, unsigned long *pulErr);
Celluar_ErrorStatus SIMCom_InputHTTPData(unsigned char *pucData, unsigned long ulLen, unsigned long ulTimeout);
Celluar_ErrorStatus SIMCom_ReadHTTPServerResponse(unsigned long ulStartAddress, unsigned long ulSize, unsigned char *pucResponse, unsigned long ulBufferLen, unsigned long *pulRespLen);
Celluar_ErrorStatus SIMCom_TerminateHTTPService(void);
#endif
#endif
#endif
