#ifndef __FSAD_H__
#define __FSAD_H__

#ifdef __cplusplus
extern "C"
{
#endif

#define  WCP_MAX_NUM    495
typedef enum {
    WCP_OK = 0,
    WCP_FRAME_NOT_COMPLETE,        // 不完整的帧
    WCP_FRAME_CRC_ERROR,           // CRC校验错误  
    WCP_NO_REG_CB,                 // 没有注册回调
    WCP_NO_COMPLETE,               // 数据未完成
    WCP_APKG_LOSS,                 // 数据丢包
    WCP_NO_DATA,                   // 没有获得数据
    WCP_TIME_OUT,                  // 超时
    WCP_OTHER_ERROR                // 其他错误   
}eWCPinfo;

typedef enum {
   ADDR_WRITE = 0,           //  写入
   ADDR_READ,                //  读取
   ADDR_ERROR
} eWCPoperate;

typedef struct {
    char           head[4];
    unsigned int   code;
    unsigned int   data_size;
    char           tail[2];
} access_frame;

typedef struct {
    char            head[4];
    unsigned int    code;
    unsigned int    current_id;
    unsigned int    total_pack_id;
    unsigned short  data_size;
    char            *data;
    unsigned short  crc;
    char            tail[2];   
} data_frame;

char            *fsad_get_request_pack(unsigned int usCode, unsigned int usSize);
char            *fsad_get_data_pack(unsigned int usCode, unsigned int current_id, 
                    unsigned int total_pack_id, unsigned short data_size, char *data, unsigned int *size);
eWCPinfo        fsad_data_frame_parsing(void const *sorData, unsigned short sorSize, data_frame *dafr);
eWCPinfo        fsad_access_frame_parsing(void const *sorData, unsigned short sorSize, access_frame *acfr);
eWCPoperate     fsad_confirm_the_frame_type(char const *ucData);


#ifdef __cplusplus
}
#endif

#endif
