/* Includes ------------------------------------------------------------------*/
#include "acc_pin.h"
#include "common.h"
#include "driver/gpio.h"
#include "esp_rom_gpio.h"

#define GPIO_WAKEUP_1    21
#define GPIO_WAKEUP_2    47
#define GPIO_WAKEUP_3    48
#define GPIO_WAKEUP_4    35
#define GPIO_WAKEUP_5    36
#define GPIO_WAKEUP_6    37


static int g_xAccPinList[ACC_MAX_SENSOR_COUNT] = {
    GPIO_WAKEUP_1,
    GPIO_WAKEUP_2,    
    GPIO_WAKEUP_3,    
    GPIO_WAKEUP_4,    
    GPIO_WAKEUP_5,    
    GPIO_WAKEUP_6, 
};

void Acc_PinInit(void)
{
    esp_rom_gpio_pad_select_gpio(GPIO_WAKEUP_1);  
	gpio_set_direction(GPIO_WAKEUP_1, GPIO_MODE_OUTPUT); 
    esp_rom_gpio_pad_select_gpio(GPIO_WAKEUP_2);  
	gpio_set_direction(GPIO_WAKEUP_2, GPIO_MODE_OUTPUT); 
    esp_rom_gpio_pad_select_gpio(GPIO_WAKEUP_3);  
	gpio_set_direction(GPIO_WAKEUP_3, GPIO_MODE_OUTPUT); 
    esp_rom_gpio_pad_select_gpio(GPIO_WAKEUP_4);  
	gpio_set_direction(GPIO_WAKEUP_4, GPIO_MODE_OUTPUT); 
    esp_rom_gpio_pad_select_gpio(GPIO_WAKEUP_5);  
	gpio_set_direction(GPIO_WAKEUP_5, GPIO_MODE_OUTPUT); 
    esp_rom_gpio_pad_select_gpio(GPIO_WAKEUP_6);  
	gpio_set_direction(GPIO_WAKEUP_6, GPIO_MODE_OUTPUT); 
}

void Acc_Enable(unsigned char ucSensorStatus)
{
    int i;
	//上升沿-使能 下降沿-失能
	for (i = 0;i < ACC_MAX_SENSOR_COUNT;i++)
	{
		if (((ucSensorStatus >> i) & 0x01) != 0)
		{
			gpio_set_level(	g_xAccPinList[i] , 1);
		}
		else
		{
			gpio_set_level(	g_xAccPinList[i] , 0);
		}
	}
}