/* Includes ------------------------------------------------------------------*/
#include "key.h"
#include "driver/gpio.h"
#include "esp_rom_gpio.h"

/* Private macros ------------------------------------------------------------*/
#define KEY_PIN				7

/* Private functions ---------------------------------------------------------*/
static void Key_ConfigureGPIO(void);

/**
  * @brief  Key Init
  * @retval None
  */
void Key_Init()
{
	Key_ConfigureGPIO();
}

/**
  * @brief  Read Key
  * @retval true / false
  */
bool Key_Read()
{
	return gpio_get_level(KEY_PIN) ? true : false;
}

static void Key_ConfigureGPIO()
{
	  gpio_config_t io_conf = {};
    io_conf.intr_type = GPIO_INTR_DISABLE;
    io_conf.mode = GPIO_MODE_INPUT;
    io_conf.pin_bit_mask = 1 << KEY_PIN;
    io_conf.pull_down_en = GPIO_PULLDOWN_DISABLE;
    io_conf.pull_up_en = GPIO_PULLUP_ENABLE;
    gpio_config(&io_conf);
}
