/* Includes ------------------------------------------------------------------*/
#include <string.h>
#include "celluar_queue.h"

/**
  * @brief  Celluar queue is empty
  * @param  pxQueue: Queue pointer
  * @retval true (empty) / false
  */
bool Celluar_QueueIsEmpty(Celluar_Queue *pxQueue)
{
	if (pxQueue != NULL)
		return (bool)(!pxQueue->bQueueFull && pxQueue->ulFront == pxQueue->ulRear);
	
	return false;
}

/**
  * @brief  Celluar queue is full
  * @param  pxQueue: Queue pointer
  * @retval None
  */
bool Celluar_QueueIsFull(Celluar_Queue *pxQueue)
{
	if (pxQueue != NULL)
		return pxQueue->bQueueFull;
	
	return true;
}

/**
  * @brief  Celluar queue push
  * @param  pxQueue: Queue pointer
  * @retval None
  */
void Celluar_QueuePush(Celluar_Queue *pxQueue)
{
	if (!Celluar_QueueIsFull(pxQueue))
	{
		pxQueue->ulRear = (pxQueue->ulRear + 1) % CELLUAR_QUEUE_SIZE;
		pxQueue->bQueueFull = (pxQueue->ulFront == pxQueue->ulRear ? true : pxQueue->bQueueFull);
	}
}

/**
  * @brief  Celluar queue pop
  * @param  pxQueue: Queue pointer
  * @retval None
  */
void Celluar_QueuePop(Celluar_Queue *pxQueue)
{
	if (!Celluar_QueueIsEmpty(pxQueue))
	{
		if(pxQueue != NULL && pxQueue->ulFront < 2) {
			memset(pxQueue->xReceiveBuffer[pxQueue->ulFront].ucBuffer, 0, pxQueue->xReceiveBuffer[pxQueue->ulFront].ulBufferLen);
			pxQueue->xReceiveBuffer[pxQueue->ulFront].ulBufferLen = 0;
			pxQueue->ulFront = (pxQueue->ulFront + 1) % CELLUAR_QUEUE_SIZE;
			pxQueue->bQueueFull = false;
		}
	}
}




