#ifndef CELLUAR_SOCKET_H
#define CELLUAR_SOCKET_H
#include "celluar_comm.h"
#include "common.h"

#if CELLUAR_TCPIP_ENABLE > 0
/* Exported macros -----------------------------------------------------------*/
#define CELLUAR_MAX_MODE_SIZE				8
#define CELLUAR_MAX_HOST_SIZE				100
#define CELLUAR_MAX_PORT_SIZE				8

/* Exported types ------------------------------------------------------------*/
typedef struct
{
	char cMode[CELLUAR_MAX_MODE_SIZE];						//TCP UDP SERVER
	char cDestinationHost[CELLUAR_MAX_HOST_SIZE];			//目标ip or 域名
	char cDestinationPort[CELLUAR_MAX_PORT_SIZE];			//目标端口
	bool bStatus;											//网络是否正常
	bool bUsed;												//是否被使用
#if CELLUAR_RECONNECT_ENABLE > 0
	bool bReconnectEnable;									//用户手动连接一次后开启自动重连
#endif
} Celluar_Socket;

/* Exported functions --------------------------------------------------------*/
long Celluar_CreateSocket(char *pcMode, char *pcHost, char *pcPort);
void Celluar_ChangeConnectInfo(unsigned long ulSocketID, char *pcMode, char *pcHost, char *pcPort);
void Celluar_ReleaseSocket(unsigned long ulSocketID);
void Celluar_SetSocketStatus(unsigned long ulSocketID, bool bStatus);
bool Celluar_GetSocketStatus(unsigned long ulSocketID);

/* Exported variables --------------------------------------------------------*/
extern unsigned long 	g_ulMaxSocketID;
extern Celluar_Socket 	g_xCelluarSocket[];
#endif
#endif


